CertificateRequestMessageBuilder (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.cert.crmf

## Class CertificateRequestMessageBuilder

- java.lang.Object
- - org.bouncycastle.cert.crmf.CertificateRequestMessageBuilder

- Direct Known Subclasses:
    JcaCertificateRequestMessageBuilder

      public class CertificateRequestMessageBuilder
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CertificateRequestMessageBuilder(java.math.BigInteger certReqId)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CertificateRequestMessageBuilder` | `addControl(Control control)`
    `CertificateRequestMessageBuilder` | `addExtension(org.bouncycastle.asn1.ASN1ObjectIdentifier oid, boolean critical, org.bouncycastle.asn1.ASN1Encodable value)`
    `CertificateRequestMessageBuilder` | `addExtension(org.bouncycastle.asn1.ASN1ObjectIdentifier oid, boolean critical, byte[] value)`
    `CertificateRequestMessage` | `build()`
    `CertificateRequestMessageBuilder` | `setAuthInfoPKMAC(PKMACBuilder pkmacBuilder, char[] password)`
    `CertificateRequestMessageBuilder` | `setAuthInfoSender(org.bouncycastle.asn1.x509.GeneralName sender)`
    `CertificateRequestMessageBuilder` | `setAuthInfoSender(org.bouncycastle.asn1.x500.X500Name sender)`
    `CertificateRequestMessageBuilder` | `setIssuer(org.bouncycastle.asn1.x500.X500Name issuer)`
    `CertificateRequestMessageBuilder` | `setProofOfPossessionRaVerified()`
    `CertificateRequestMessageBuilder` | `setProofOfPossessionSigningKeySigner(ContentSigner popSigner)`
    `CertificateRequestMessageBuilder` | `setProofOfPossessionSubsequentMessage(org.bouncycastle.asn1.crmf.SubsequentMessage msg)`
    `CertificateRequestMessageBuilder` | `setPublicKey(org.bouncycastle.asn1.x509.SubjectPublicKeyInfo publicKey)`
    `CertificateRequestMessageBuilder` | `setSerialNumber(java.math.BigInteger serialNumber)`
    `CertificateRequestMessageBuilder` | `setSubject(org.bouncycastle.asn1.x500.X500Name subject)`
    `CertificateRequestMessageBuilder` | `setValidity(java.util.Date notBeforeDate, java.util.Date notAfterDate)` Request a validity period for the certificate.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CertificateRequestMessageBuilder

          public CertificateRequestMessageBuilder(java.math.BigInteger certReqId)

  - ### Method Detail

    - #### setPublicKey

          public CertificateRequestMessageBuilder setPublicKey(org.bouncycastle.asn1.x509.SubjectPublicKeyInfo publicKey)

    - #### setIssuer

          public CertificateRequestMessageBuilder setIssuer(org.bouncycastle.asn1.x500.X500Name issuer)

    - #### setSubject

          public CertificateRequestMessageBuilder setSubject(org.bouncycastle.asn1.x500.X500Name subject)

    - #### setSerialNumber

          public CertificateRequestMessageBuilder setSerialNumber(java.math.BigInteger serialNumber)

    - #### setValidity

          public CertificateRequestMessageBuilder setValidity(java.util.Date notBeforeDate,
                                                     java.util.Date notAfterDate)

      Request a validity period for the certificate. Either, but not both, of the date parameters may be null.
      Parameters:
        `notBeforeDate` - not before date for certificate requested.
        `notAfterDate` - not after date for the certificate requested.
      Returns:
        the current builder.

    - #### addExtension

          public CertificateRequestMessageBuilder addExtension(org.bouncycastle.asn1.ASN1ObjectIdentifier oid,
                                                      boolean critical,
                                                      org.bouncycastle.asn1.ASN1Encodable value)
                                                        throws CertIOException

      Throws:
        `CertIOException`

    - #### addExtension

          public CertificateRequestMessageBuilder addExtension(org.bouncycastle.asn1.ASN1ObjectIdentifier oid,
                                                      boolean critical,
                                                      byte[] value)

    - #### addControl

          public CertificateRequestMessageBuilder addControl(Control control)

    - #### setProofOfPossessionSigningKeySigner

          public CertificateRequestMessageBuilder setProofOfPossessionSigningKeySigner(ContentSigner popSigner)

    - #### setProofOfPossessionSubsequentMessage

          public CertificateRequestMessageBuilder setProofOfPossessionSubsequentMessage(org.bouncycastle.asn1.crmf.SubsequentMessage msg)

    - #### setProofOfPossessionRaVerified

          public CertificateRequestMessageBuilder setProofOfPossessionRaVerified()

    - #### setAuthInfoPKMAC

          public CertificateRequestMessageBuilder setAuthInfoPKMAC(PKMACBuilder pkmacBuilder,
                                                          char[] password)

    - #### setAuthInfoSender

          public CertificateRequestMessageBuilder setAuthInfoSender(org.bouncycastle.asn1.x500.X500Name sender)

    - #### setAuthInfoSender

          public CertificateRequestMessageBuilder setAuthInfoSender(org.bouncycastle.asn1.x509.GeneralName sender)

    - #### build

          public CertificateRequestMessage build()
                                          throws CRMFException

      Throws:
        `CRMFException`